package com.itheima.mail;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.Socket;
import java.util.Random;

import com.sun.org.apache.xerces.internal.impl.dv.util.Base64;

public class Sender {
	private String mailSmtpServer;
	private int post = 25;
	private String user;
	private String passWord;
	private String from;
	private String to;
	private String subject;
	private String content;
	
	
	
	Socket socket = null;
	DataOutputStream outData = null;
	BufferedReader inData = null;
	
	private boolean connection = false;

	public final static String LINE_FEED = "\r\n";
	
	public Sender(String mailSmtpServer,String user,String passWord) throws Exception {
		if(mailSmtpServer == null || user == null || passWord == null)return;
		if("".equals(mailSmtpServer) || "".equals(user) || "".equals(passWord))return;
		this.mailSmtpServer = mailSmtpServer;
		this.user = user;
		this.passWord = passWord;
		init();
	}
	
	public void init() throws Exception{
		this.socket = new Socket(this.mailSmtpServer, this.post);
		if(!socket.isConnected()){
			socket.close();
			return;
		}
		connection = true;
		outData = new DataOutputStream(socket.getOutputStream());
		inData = new BufferedReader(new InputStreamReader(socket.getInputStream()));
		// ʼӳɹ
		readResponse("220");
	}
	
	public boolean send() throws Exception{
		if(from == null || "".equals(from) || to == null || "".equals(to))return false;
		
		// HELO host
		sendRequest("HELO " + this.mailSmtpServer + LINE_FEED);
		if(!readResponse("250"))return false;
			// AUTH LOGIN
		sendRequest("AUTH LOGIN" + LINE_FEED);
		if(!readResponse("334"))return false;
		//USERNAME: 
		sendRequest(Base64.encode(this.user.getBytes()) + LINE_FEED); 
		if(!readResponse("334"))return false; 
		//PASSWORD: 
		sendRequest(Base64.encode(this.passWord.getBytes())+LINE_FEED);
		if(!readResponse("235"))return false; 
		// MAIL FROM:<..>
		sendRequest("MAIL FROM:<" + from + ">" + LINE_FEED);
		if(!readResponse("250"))return false;
		// RCPT TO:<..>
		sendRequest("RCPT To:<" + to + ">" + LINE_FEED);
		if(!readResponse("250"))return false;
		// DATA
		sendRequest("DATA" + LINE_FEED);
		if(!readResponse("354"))return false;
		// ʼ
		StringBuffer s1 = new StringBuffer("From:<" + from + ">"
				+ LINE_FEED);
		s1.append("To:<" + to + ">" + LINE_FEED);
		s1.append("Subject:" + "=?GB2312?B?" + Base64.encode(new String(subject.getBytes(),"GB2312").getBytes()) + "?=" + LINE_FEED);
		s1.append("Mime-Version: 1.0");
		s1.append("Content-Type:text/plain;charset=\"GB2312\"" + LINE_FEED);
		s1.append(LINE_FEED);
		System.out.println(content);
		s1.append(content);
		s1.append(LINE_FEED);
		//һΪʼ
		s1.append(this.randomStr(50));
		s1.append(LINE_FEED + "." + LINE_FEED);// 
		sendRequest(s1.toString());
		if(!readResponse("250"))return false;
		// QUIT˳
		sendRequest("QUIT" + LINE_FEED);
		if(!readResponse("221"))return false;
		return true;
	}

	public void close() throws IOException{
		this.socket.close();
		if(this.inData != null )this.inData.close();
		if(this.outData != null )this.outData.close();
	}
	
	private boolean readResponse(String cmd) throws Exception {
		String tmp = inData.readLine();
		if (tmp.startsWith(cmd)){
			System.out.println(tmp);
			return true;
		} else{
			return false;			
		}
	}

	private void sendRequest(String msg) throws IOException {
		outData.writeBytes(msg);
		outData.flush();
	}
	
	public int getPost() {
		return post;
	}

	public String getFrom() {
		return from;
	}

	public void setFrom(String from) {
		this.from = from;
	}

	public String getTo() {
		return to;
	}

	public void setTo(String to) {
		this.to = to;
	}

	public String getSubject() {
		return subject;
	}

	public void setSubject(String subject) {
		this.subject = subject;
	}

	public boolean isConnection() {
		return connection;
	}
	
	
	public String getContent() {
		return content;
	}

	public void setContent(String content) {
		this.content = content;
	}
	
	public String randomStr(int length){
		char[] random = {'0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'};
		String result = "";
		while(length >0){
			int ran = new Random().nextInt(36);
			result += random[ran];
			length -- ;
		}
		return result;
	}

	public static void main(String[] args) throws Exception{
//		Sender sender = new Sender("smtp.qq.com", "madgin@qq.com", "majinluyia");
//		sender.setFrom("madgin@qq.com");
//		sender.setTo("madgin@qq.com");
//		sender.setSubject("");
//		sender.setContent("ԣ");
//		sender.send();
//		sender.close();
		int ran = new Random().nextInt(36);
		System.out.println(ran);
		System.out.println((50));
		
		
	}

}
